using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using Microsoft.EntityFrameworkCore;

namespace Strata.Code.DataAccess.Models;

[PrimaryKey("BudgetConfigId", "EntityId", "ServiceLineId", "PatientClassId")]
[Table("ServiceLineEncounterSpreads", Schema = "fp")]
public partial class ServiceLineEncounterSpread
{
    [Key]
    [Column("BudgetConfigID")]
    public int BudgetConfigId { get; set; }

    [Key]
    [Column("EntityID")]
    public int EntityId { get; set; }

    [Key]
    [Column("ServiceLineID")]
    public int ServiceLineId { get; set; }

    [Key]
    [Column("PatientClassID")]
    public int PatientClassId { get; set; }

    public bool IsInactive { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage01 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage02 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage03 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage04 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage05 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage06 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage07 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage08 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage09 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage10 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage11 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? SpreadPercentage12 { get; set; }

    [Column(TypeName = "decimal(18, 0)")]
    public decimal? TotalImportedValue { get; set; }

    [Column("SpreadHistoryGUID")]
    public Guid SpreadHistoryGuid { get; set; }

    [Column("GlobalSpreadID")]
    public int GlobalSpreadId { get; set; }

    [ForeignKey("SpreadHistoryGuid")]
    [InverseProperty("ServiceLineEncounterSpreads")]
    public virtual SpreadHistory SpreadHistory { get; set; } = null!;
}
